/*	
 *	menu.c
 *
 *	3MHzj[
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Sun Oct 20 10:04:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	  c:\usr\PIECE\app\menu2\menu.cx[Xɉ܂B
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <piece.h>
#include <s1c33cpu.h>
#include "launch.h"
#include "c33209.h"
#include "d12ci.h"

extern int OS_Main(void);

/****************************************************************************
 *	萔
 ****************************************************************************/

#define CPU_SPEED	3	/* 0:24MHz/1:12MHz/2:6MHz/3:3MHz */

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

unsigned char vbuff[128 * 88];
unsigned char pos;
unsigned char draw = 1; /* ĕ`tO */
PCEPWRSTAT prev_ps; /* obeԕωop */

/****************************************************************************
 *	pceAppInit/Exit/Proc
 ****************************************************************************/

void
pceAppInit()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(40);
	pceLCDDispStart();

	/* CPȖxύX܂B */
	pceCPUSetSpeed(CPU_SPEED); /* pceAppExit()Ŗ߂ƁI */

	/* Ԃ񂱂ꂪ΂dCȂUSBC̐ݒłB
	 * D12_CLOCKRUNNINǴAUSBC쓮ɂsvƎv܂B
	 * ̃tOɂĂ̋LqȂ̂ŁAłF
	 *
	 *	D12_CLOCKRUNNING:
	 *	̃tOw肷ƁAUSBʐMłȂĂUSBCÂ܂B
	 *	̃tOw肵ȂƁAUSBʐMȊOUSBC͎~܂܂B
	 *	USBP[uڑĂƁAAvP[VCŒʐMsĂȂĂA
	 *	USB̃Cł͒ʐMƌȂ܂B
	 *	]āAUSBP[uڑ́ÃtO̗LɊւ炸USBC͓Â܂B
	 *
	 * USBP[uڑĂȂ̂USBCĂdȂ̂ŁA
	 * ȂƂP/ECEł͂̃tOKvɂȂ邱Ƃ͐΂ɂȂƎv܂B
	 *
	 * ł͂ǂ̂悤ȏ󋵂ł̃tOKvȂ̂zĂ݂܂ƁA
	 * CPUg₻̑̎ӑuUSBCNbN󂯂ĂꍇƎv܂B
	 * USBC~܂Ă܂ƁAUSBC̃NbN~܂Ă܂̂ŁA
	 * USBʐM̗LɊւ炸Âė~HꍇÃtOĝƎv܂B
	 * iP/ECEł́AUSBC̃NbNo͒[q͎gĂȂ̂ŁÃP[Xɂ͓Ă͂܂܂j
	 *
	 * Ȃ݂ɂ̏ꍇAUSBʐM̓tXs[hŁEʐM̖Ƃ͂蓮
	 * d͏}邽߂ɁAD12_NOLAZYCLOCKtÔƎv܂B
	 */
	D12_SetMode(D12_SOFTCONNECT | D12_ENDP_NONISO, D12_SETTOONE | D12_CLOCK_4M); /* ߂KvȂI */
}

void
pceAppExit()
{
	/* CPȖx𕜌܂B */
	pceCPUSetSpeed(CPU_SPEED_NORMAL);
}

void
pceAppProc(int count)
{
	int pad;
	PCEPWRSTAT ps;

	/* X^oCH */
	pad = pcePadGet();
	if(pad) getdir();
	if((pad & TRG_B) && (pad & PAD_SELECT)) {
		go_standby();
		draw = 4; /* Aĕ`v */
	}

	/* W̃j[B
	 * * draw0ȊO̒lɂČĂяoƁAĕ`ɂȂ܂B
	 *   draw=0ŌĂяoĂAt@CIύXȂǂ̗Rɂĕ`悪sꂽA
	 * * draw0ȊO̒lɂȂċAĂ܂B
	 */
	OS_Main();

	/* ĕ`悳ꂽobeԂωAʓ]܂B */
	pcePowerGetStatus(&ps);
	if(draw || memcmp(&prev_ps, &ps, sizeof(PCEPWRSTAT)) != 0) {
		pceLCDTrans();
		draw = 0;
	}
	prev_ps = ps;
}

/****************************************************************************
 *	pceCPUSetSpeedipceapi.lib̓֐u܂j
 ****************************************************************************/

typedef struct _CPUSPDTBL {
	unsigned char lcd_clksel;
	unsigned char lcd_clkdiv;
	unsigned char usb_wait;
	unsigned char mem_wait;
} CPUSPDTBL;
/* 6MHzE3MHzł́AVA]CPỦzʃRo[gɒǂzĂ܂܂I
 * VȂxグĂAVAɃNbNĂ8rbg^C}ɂ
 * CPUȏ̃NbN邱Ƃ͂łȂƂɂȂĂ܂B
 * iȂ݂Ɍ݂P/ECEJ[l͂ɈᔽĂ邩6MHzA3MHzgȂ̂ł(^^;j
 * 8rbg^C}̃v[hl͊1ŁA炵0ɂ͂ł͂Ȃ̂łA
 * ۂɂĂ݂ƂȂF܂iv[hl0̓_Ȃł傤Hj
 * Ƃ킯ŁAƂCPUɃEFCg܂܂B
 * KAP/ECEJ[l͉zʌ`ϊLCD]obt@RAMɎĂ̂ŁA
 * SRAMƃtbṼEFCg𑝂₹CPUɃEFCg肻łB
 * zʃRo[gvO͈ꎞIɓRAMɃRs[ē̂ŁA
 * zʃRo[gvÔxȂ킯ł͂܂񂪁A
 * ̑̃R[hxȂ̂ŁAʓIɒǂ͔ȂȂ悤łB
 */
const CPUSPDTBL cpuspdtbl[4] = {
	{ 1, 0, 4, 2 },
	{ 0, 0, 2, 2 },
	{ 0, 1, 1, /*1*/2 }, /* Ƃ킯ŁA6MHzA3MHz̃EFCg */
	{ 0, 2, 1, /*1*/2 }, /*   KvȃEFCgl߂ɂƂĂ܂B */
};

int
pceCPUSetSpeed(int speed)
{
	int old_speed;
	const CPUSPDTBL* csp;

	speed &= 3;
	csp = cpuspdtbl + speed;

	DISABLE;

	old_speed = bPWR_CTL_CLKDT;

	/* ^C}~NbNύX^C}ĊJ
	 * 24MHzȊÓA8rbg^C}̃v[hl炵
	 *   łVAxグƂłA_łB
	 *   12MHzȊOł́Aʂ̐FȂĂ܂܂BȂH
	 */
	bCLKCTL_T8_45_P8TON5 = 0;
	bCLKSEL_T8_45_P8TPCK5 = csp->lcd_clksel;
	bCLKCTL_T8_45_P8TS5 = csp->lcd_clkdiv;
	bCLKCTL_T8_45_P8TON5 = 1;

	/* EFCgő偨NbNύXEFCg */
	bA6_4_A5WT = 7;
	bA8_7_A8WT = 7;
	bA10_9_A10WT = 7;
	pPWR_CLGP = 0x96;
	bPWR_CTL_CLKDT = speed;
	bA6_4_A5WT = csp->mem_wait;
	bA8_7_A8WT = csp->usb_wait;
	bA10_9_A10WT = csp->mem_wait;

	ENABLE;

	return old_speed;
}
